
#ifndef KVBufferINCLUDED
#define KVBufferINCLUDED


#include "error.h"


#define MAX_NB_PAIRS  32
#define MAX_KEY_LEN   128
#define MAX_VALUE_LEN 128






class Pair
{
public:
  char key_[MAX_KEY_LEN];
  char value_[MAX_VALUE_LEN];
};


class KVBuffer
{
public:
  KVBuffer();
  ~KVBuffer();

  bool initialize(const char* iBuf);
  void reset();

  const char* getValue(const char* key) const;
  int getIntValue(const char* key) const;

  bool addKeyValue(const char* key, const char* value);
  bool addKeyIntValue(const char* key, int value);
  bool getString(char* obuf, int obuf_len) const;

  int nbPairs_;

  Pair pairs_[MAX_NB_PAIRS];

};

#endif
