#include "Serv.h"
#include "Service.h"


// DEBUG stuff ////////////////////////////////////

	char* errlogMain = "errMainLog.txt";
	
///////////////////////////////////////////////////


// Globale variabler //////////////////////////////

HANDLE		hCpuLoadThrd;
DWORD		dwCpuLoadThrdId;

///////////////////////////////////////////////////

//
// Start the service
//

void ServiceStart(DWORD dwArgc, LPTSTR *lpszArgv){ 

	COORD		pos;
	LPTSTR		title = "CPU%";
	HANDLE		hScreen;	
	
	SOCKET		servSock;
	SA			cliaddr;
	
	int			len = sizeof(cliaddr);
	int			err, WSAerr;
	int			servPort;
	
	char		ibuf[BUF_SIZE]; 
	char		obuf[BUF_SIZE];
	char		passwd[MAX_PASSWD_LEN];

	
	
	CONSOLE_CURSOR_INFO lpConsoleCursorInfo;		
	
	hScreen = GetStdHandle(STD_OUTPUT_HANDLE);
		
	SetConsoleTitle(title);
	pos.X=0; pos.Y=1;
	
	lpConsoleCursorInfo.bVisible = 0;
	lpConsoleCursorInfo.dwSize = 1;

	
	ReportStatusToSCMgr(SERVICE_START_PENDING,NO_ERROR,30000);
	
	//SetConsoleCursorInfo(hScreen, &lpConsoleCursorInfo);	
	PrintOK("---- STARTER ----",errlogMain);

	ReportStatusToSCMgr(SERVICE_START_PENDING,NO_ERROR,30000);

	// Hent passord og portnummer fra startup.ini
	err = ReadInitData(passwd, servPort);
	if( err != NOERR ) {
		PrintError(err, "ReadPasswd", errlogMain);		
		//return 1;
	}
	PrintOK("ReadInitData",errlogMain);		

	ReportStatusToSCMgr(SERVICE_START_PENDING,NO_ERROR,30000);
	
	// Oppretter UDP-socketen	
	err = CreateUDPSocket(servSock, servPort);
	if(err != NOERR) {
		// Utskrift av feilmeldinger i CreateUDPSocket			
		//return 1;
	}
	PrintOK("CreateUDPSocket",errlogMain);

	ReportStatusToSCMgr(SERVICE_START_PENDING,NO_ERROR,30000);

	// Klargjr kritisk seksjon fr vi starter CPU% mle trden
	InitializeCriticalSection(&ProcessAccess);	
	
	
	// Starter trden som foretar CPU% mling
	hCpuLoadThrd = CreateThread( NULL,
							0,
							CollectCpuLoad,
							NULL,
							0,
							&dwCpuLoadThrdId );	
	
	if( hCpuLoadThrd == NULL ) {
		PrintError(ERR_CREATE_THREAD, "CreateThread", errlogMain);		
		//return 1;
	}
	PrintOK("CreateThread",errlogMain);		

	cout << "Server startet..." << endl;
	SetConsoleCursorInfo(hScreen, &lpConsoleCursorInfo);

	ReportStatusToSCMgr(SERVICE_RUNNING,NO_ERROR,30000);

	// Her begynner starter kommunikasjon med klient
	while(1) {
		// Motta klient-foresprsel
		PrintOK("recvfrom: Venter",errlogMain);
		err = recvfrom(servSock, ibuf, sizeof(ibuf), 0, (sockaddr *) &cliaddr, &len);		
		WSAerr = WSAGetLastError();

		if(err == SOCKET_ERROR) {
			PrintError(ERR_SOCKET, "recvfrom", errlogMain);
			PrintSocketError(WSAerr, "recvfrom", errlogMain);		
		}
		else {						
			PrintOK("recvfrom: mottatt",errlogMain);			
			strcpy(cliAddrStr, inet_ntoa((struct in_addr)cliaddr.sin_addr) );			
		
			err = AnalyzeMessage(ibuf, obuf, passwd);
			if(err != NOERR) {
				PrintError(err, "AnalyzeMessage", errlogMain);
				continue;	// Forkast og vent p ny foresprsel
			}
			PrintOK("AnalyzeMessage",errlogMain);			
			
			err = sendto(servSock, obuf, sizeof(obuf),0, (sockaddr *) &cliaddr, len);
			WSAerr = WSAGetLastError();

			if (err == SOCKET_ERROR) {
				PrintError(ERR_SOCKET, "sendto", errlogMain);
				PrintSocketError(WSAerr, "sendto", errlogMain);				
				continue;
			}
			PrintOK("sendto",errlogMain);
		}			
	} // while
	
	// Rydd opp	
	closesocket(servSock);
	WSACleanup();	
	//return 0;
}


//
// Stop the service
//
void ServiceStop (){ }


int AnalyzeMessage(char *ibuf, char *obuf, char *passwd) {
		
	int err;
	int meldType;
	char tmp[MAX_PASSWD_LEN];
	
	strncpy(tmp, &ibuf[1], MAX_PASSWD_LEN);

	err = strcmp(passwd, tmp);

	//Sjekk omm foresprselen er gyldig
	if( err != 0 ) {
		PrintError(ERR_AUTHENTICATION, "AnalyzeMessage", errlogMain);
		cout << "Authentication failed\nDiscarding message" << endl;
		return ERR_AUTHENTICATION;
	}

	meldType = (int) ibuf[0];	
	
	// Sjekker meldingstype og kaller funksjon for behandling av foresprsel
	switch( meldType ) {
	case CPU_LOAD_QUERY:		
		err = CheckThread(hCpuLoadThrd, dwCpuLoadThrdId);	// Sjekker om trden er OK, og restarter den viss noe er galt
		if(err!=NOERR)
			break;
		err = GetCPULoadInfo(ibuf, obuf);		
		break;
	default:
		err = ERR_NO_SUCH_MESSAGE;		
	}	
	
	if(err == NOERR)
		PrintComm(ibuf, obuf, meldType, MSGFILE);
	
	return err;
}

int GetCPULoadInfo(char *ibuf, char *obuf) {
	
	double load1, load2;
//	char str[256];
//	char tmp[10];

	int interval1 = ((int) ibuf[MAX_PASSWD_LEN+1])*60;	  // CPULoad interval1
	int interval2 = ((int) ibuf[MAX_PASSWD_LEN+2])*60;	  // CPULoad interval2

	//Bygg opp streng for utskrift av mottatt melding
	/*strcpy(str, "From ");
	strcat(str, cliAddrStr);
	strcat(str, "ID: ");
	strcat(str, itoa((int)ibuf[0], tmp, 10) );
	strcat(str, " Key: xxxxx");
	strcat(str, " i1: ");
	strcat(str, itoa((int)ibuf[MAX_PASSWD_LEN+1], tmp, 10) );
	strcat(str, " i2: ");
	strcat(str, itoa((int)ibuf[MAX_PASSWD_LEN+2], tmp, 10) );*/

//	PrintComm(str, "commLog.txt", true);
	
	if( (interval1 < 0) || (interval1 > CPULoadArraySize) 
		|| (interval2 < 0) || (interval2 > CPULoadArraySize))	
		return ERR_CPULOAD_INTERVAL;
	
	
	
	// Hent ut nsket informasjon	
	EnterCriticalSection(&ProcessAccess);
		load1 = CPU.ComputeAvgCPULoad(interval1);
		load2 = CPU.ComputeAvgCPULoad(interval2);

		// Meldingen som skal sendes
		obuf[0] = CPU_LOAD_QUERY; // Meldingstype
		obuf[1] = Round(load1);
		obuf[2] = Round(load2);
		obuf[3] = Round( Process.cpuLoad );		
		obuf[4] = '\0';
		strncat(&obuf[4], Process.processName, 256);		
	LeaveCriticalSection(&ProcessAccess);	
	
	return NOERR;
}

char Round(double num) {
	double tmp;
	tmp = num - floor(num);

	if(tmp < 0.5)
		return (char) num;
	else
		return ( (char) num +1);
}

/*int ReadInitData(char *passwd, int &port) {

	HANDLE		hFile;		
	int			forts=0;
	int			nLoop=0;
	char		_port[5];
	char		str[20];
		
	
	hFile = CreateFile( INIFILE, 
						GENERIC_READ,
						0,
						NULL,	// Standard sikkerhetshndtering
						OPEN_EXISTING,
						FILE_ATTRIBUTE_NORMAL,
						NULL );
	
	if(hFile == INVALID_HANDLE_VALUE)		
		return ERR_NOINIFILE;		

	do {
		ReadLine(str, hFile);
		if( strcmp(str,"key=") == 0 ) {			
			ReadLine(passwd, hFile);
			forts++;
		}
		else if( strcmp(str,"port=") == 0) {
			ReadLine(_port, hFile);
			port = atoi(_port);
			forts++;
		}

		nLoop++;				
	}
	// Dersom vi har gtt 1000 ganger gjennom lkken og ikke funnet hva vi nsker,
	// anser vi filen som feil
	while(forts<2 && nLoop<1000);  

	if( (port < 1025) | (port > 65535) )
		return ERR_PORT;
		
	//cout << passwd << endl;
	//cout << port << endl;	
	
	CloseHandle(hFile);	
	return NOERR;
} */

int CreateUDPSocket(SOCKET &servSock, int port) {
	
	struct sockaddr_in servaddr;
	WORD		wVersionRequired;
	WSADATA		wsaData;
	int err, WSAerr;
	
	/*
	 *		SOCKET INITIALISERING
	 */	

	// Spesifiserer hyeste versjon av Windows Sockets som prosessen kan benytte
	wVersionRequired = MAKEWORD(1,1);
	
	//Initialiseringen utfres.  Returnerer 0 viss vellykket, ellers feilkode
	err = WSAStartup(wVersionRequired,&wsaData); 
	WSAerr = WSAGetLastError();
	
	if(err != 0) {		
		PrintError(ERR_SOCKETINIT, "CreateUDPSocket", errlogMain);
		PrintSocketError(WSAerr, "CreateUDPSocket", errlogMain);	
		return ERR_SOCKETINIT;	
	}

	/*
	 *		SOCKET OPPRETTING
	 */

	// Oppretter en uinitialisert UDP socket
	servSock = socket( AF_INET, SOCK_DGRAM, 0);
	
	// Setter bytene i server adressen til 0
	memset(&servaddr, 0, sizeof(servaddr));

	// Initialisering av server-adressen	
	servaddr.sin_family		 = AF_INET; 
	servaddr.sin_addr.s_addr = INADDR_ANY;  // returnerer 32 bits IP-adresse i 'network byte order'
	servaddr.sin_port		 = htons(port); // returnerer 16 bits portnr. i 'network byte order'
	
	// Knytter server-adressen sammen med 'socketen'
	// Returnerer 0 viss vellykket, ellers feilkode	
	err = bind(servSock, (sockaddr *) &servaddr, sizeof(servaddr));
	WSAerr = WSAGetLastError();
	

	if (err == SOCKET_ERROR) {		
		PrintError(ERR_BIND, "CreateUDPSocket", errlogMain);
		PrintSocketError(WSAerr, "CreateUDPSocket", errlogMain);
		
		closesocket(servSock);
		WSACleanup();
		return ERR_BIND;		
	}

	return NOERR;
}

/*int CheckDll() {
	
	 DWORD   dwVerInfoSize;        // Size of version information block
	LPSTR   lpVersion;            // String pointer to 'version' text
	 DWORD   dwVerHnd=0;            // An 'ignored' parameter, always '0'
	UINT*    puVersionLen = new UINT;
	BOOL    bRetCode;

	 char szFileName[20];
	 strcpy(szFileName, "pdh.dll");

	dwVerInfoSize = GetFileVersionInfoSize(szFileName, &dwVerHnd);

	if (dwVerInfoSize) {
            LPSTR   lpstrVffInfo;
            HANDLE  hMem;
            hMem = GlobalAlloc(GMEM_MOVEABLE, dwVerInfoSize);
            lpstrVffInfo  = (char *)GlobalLock(hMem);
            bRetCode = GetFileVersionInfo("pdh.dll", dwVerHnd, dwVerInfoSize, lpstrVffInfo);
			
			if(!bRetCode)           
                cout << "GetFileVersionInfo failed" << endl;
			
            // Product Version
            bRetCode = VerQueryValue(  (LPVOID)lpstrVffInfo,
									   TEXT("\\StringFileInfo\\040904E4\\FileVersion"),
									   (LPVOID *)&lpVersion,
									   puVersionLen);

            if(bRetCode)
                cout << "ProductVersion " << lpVersion << endl;            
            else            
                cout << "ProductVersion query failed" << endl;            
            
	}

	return NOERR;
}

/*void TestCPULoad(HANDLE hScreen, CONSOLE_CURSOR_INFO lpConsoleCursorInfo) {
		int interval;
		double cpuLoad;	
		COORD pos;
		pos.X=0; pos.Y=10;
		lpConsoleCursorInfo.bVisible = 0;
		lpConsoleCursorInfo.dwSize = 1;	 

		cout << "Interval(sek): ";	
		cin >> interval;
		SetConsoleCursorInfo(hScreen, &lpConsoleCursorInfo);

		while(1) {
			SetConsoleCursorPosition(hScreen, pos);
			EnterCriticalSection(&ProcessAccess);		
			cpuLoad = CPU.ComputeAvgCPULoad(interval);
			cout <<		"Avg load: " << setprecision(3) << cpuLoad << "%\t" << endl;
			
			if( Process.cpuLoad == 0 && cpuLoad > 0)
				cout << "Process : Unknown\t\t\t\t" << endl;
			else	
				cout << "Process " << Process.processName << " using " << setprecision(3) << Process.cpuLoad << "%\t\t" << endl;
			LeaveCriticalSection(&ProcessAccess);

			Sleep(1000);
		}
}*/

/*int ReadLine(char* str, HANDLE hFile) {

	int index=0, err;
	char ch;
	DWORD nRead;
	bool eof=false;
	
	do {
		err= ReadFile( hFile,
					   &ch,
					   1,
			           &nRead,
				       NULL);

		str[index++]=ch;

		if( (err==1 && nRead==0) )			
			break;
		if( ch=='=' ) {
			index++;
			break;
		}
	}
	while( (ch!='\r') && (ch!='\n') );

	str[index-1]='\0';
	
	return NOERR;
}*/

void PrintComm(char* ibuf, char* obuf, int msgType, char* log) {
	ofstream of(log, ios::app);
	char str[500];
	char tmp[10];
	
	switch(msgType)
	{
	case CPU_LOAD_QUERY:
		// Mottatt
		strcpy(str, "From ");
		strcat(str, cliAddrStr);
		strcat(str, ": ID:");
		strcat(str, itoa((int)ibuf[0], tmp, 10) );
		strcat(str, " Key:xxxxx");
		strcat(str, " i1:");
		strcat(str, itoa((int)ibuf[MAX_PASSWD_LEN+1], tmp, 10) );
		strcat(str, " i2:");
		strcat(str, itoa((int)ibuf[MAX_PASSWD_LEN+2], tmp, 10) );
		of << str << endl;

		// Sender
		strcpy(str, "Reply: ");
		strcat(str, "ID:");
		strcat(str, itoa((int)obuf[0], tmp, 10) );
		strcat(str, " l1:");
		strcat(str, itoa((int)obuf[1], tmp, 10) );
		strcat(str, " l2:");
		strcat(str, itoa((int)obuf[2], tmp, 10) );
		strcat(str, " pLoad:");
		strcat(str, itoa((int)obuf[3], tmp, 10) );
		strcat(str, " pName:");
		strcat(str, &obuf[4]);
		of << str << endl;
		break;
	default:
		of << "Error in message format" << endl;
	}
	
	
	of.close();
}

int ReadInitData(char *passwd, int &port)
{
	HANDLE		hFile;		
	int			forts=0;
	int			nLoop=0;
	char		_port[5];

	int			strSize=100;
	char*		str = new char[strSize];
		
	
	hFile = CreateFile( INIFILE, 
						GENERIC_READ,
						0,
						NULL,	// Standard sikkerhetshndtering
						OPEN_EXISTING,
						FILE_ATTRIBUTE_NORMAL,
						NULL );
	
	if(hFile == INVALID_HANDLE_VALUE) {		
		return 1;//ERR_NOINIFILE;		
	}

	do {
		ReadLine(str, strSize, hFile);
		if( strcmp(str,"key=") == 0 ) {			
			ReadLine(passwd, strSize, hFile);
			forts++;
		}
		else if( strcmp(str,"port=") == 0) {
			ReadLine(_port, strSize, hFile);
			port = atoi(_port);
			forts++;
		}

		nLoop++;				
	}
	// Dersom vi har gtt 1000 ganger gjennom lkken og ikke funnet hva vi nsker,
	// anser vi filen som feil
	while(forts<2 && nLoop<1000); 
	
	delete str;
	
	if(nLoop==1000) {		
		CloseHandle(hFile);
		return 2; //Filformat error			
	}

	CloseHandle(hFile);	
	return NOERR;;//NOERR;
}

int ReadLine(char *str, int strSize, HANDLE hFile)
{
	int index=0, err;
	char ch=' ', forrige=' ';
	DWORD nRead;
	bool eof=false;
	bool br=false;
	
	//int len = strlen(str);

	while(index < strSize) {
		forrige=ch;
		err= ReadFile( hFile,
					   &ch,
					   1,
			           &nRead,
				       NULL);

		str[index++]=ch;

		if( (err==1 && nRead==0) ) { // End of file
			str[index-1]='\0';
			return NOERR;;
		}

		if( ch=='\x0a' && forrige=='\x0d') {	// Endo of line
			str[index-2]='\0';
			return NOERR;;			
		}
		
		if( ch=='=' ) {
			str[index]='\0';			
			return NOERR;;
		}		
	}

	return 1; //ERROR
}

int CheckThread(HANDLE hCpuLoadThrd, DWORD &dwCpuLoadThrdId) {
// Viss CPU-Load-trden har avsluttet seg selv, prv  strate den p nytt
	if(hCpuLoadThrd==NULL) {
		// Vent litt og start trden p nytt
		Sleep(500);

		hCpuLoadThrd = CreateThread( NULL,
						0,
						CollectCpuLoad,
						NULL,
						0,
						&dwCpuLoadThrdId );

		Sleep(500);

		if( hCpuLoadThrd == NULL ) { // Serious error
			PrintError(ERR_CREATE_THREAD, "CreateThread", errlogMain);		
			return ERR_CREATE_THREAD;
		}
	}

	return NOERR;
}

