
#include "common.h" 

#include "../../../Common/error.h"



const TCHAR* CPULOG   = "errCPUThrdLog.log";	// file to log errors
const TCHAR* MSGFILE  = "msgs.log";
const TCHAR* ERRLOG   = "NSServ.log";
const TCHAR* SOCKLOG  = "socket.log";







/*
void PrintSocketError(int errCode, char* where, const char* errlog)
{
ofstream of(errlog, ios::app);

  cout << "WSAError: " << errCode << " in " << where << endl;
  of   << "WSAError: " << errCode << " in " << where << endl;
  of.close();
  }
*/


/*
void PrintToFile(char* str, char* file) 
{

  char date[9];
  char time[9];
  
    ofstream of(file, ios::app);
    
      _tzset();
      
        cout << _strdate( date ) << " " << _strtime( time ) << " ";
        cout << str << endl;      
        
          of << _strdate( date ) << " " << _strtime( time ) << " ";
          of << str << endl;
          
            of.close();
            }
*/











LPTSTR GetLastErrorText(DWORD err)
{
  TCHAR str[2048];
  return GetLastErrorText(str, 2048, err);
}

LPTSTR GetLastErrorText()
{
  return GetLastErrorText(GetLastError());
}

LPTSTR GetLastErrorText( LPTSTR lpszBuf, DWORD dwSize, DWORD dwErr )
{
  DWORD dwRet;
  LPTSTR lpszTemp = NULL;
  
  dwRet = FormatMessage( FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM |FORMAT_MESSAGE_ARGUMENT_ARRAY,
    NULL,
    dwErr,
    LANG_NEUTRAL,
    (LPTSTR)&lpszTemp,
    0,
    NULL );
  
  // supplied buffer is not long enough
  if ( !dwRet || ( (long)dwSize < (long)dwRet+14 ) )
    lpszBuf[0] = TEXT('\0');
  else
  {
    lpszTemp[lstrlen(lpszTemp)-2] = TEXT('\0');  //remove cr and newline character
    _stprintf( lpszBuf, TEXT("%s (0x%x)"), lpszTemp, GetLastError() );
  }
  
  if ( lpszTemp )
    LocalFree((HLOCAL) lpszTemp );
  
  return lpszBuf;
}





char* getTimeDateString(int level)
{
  static char str[1000];
  char* errorType = "PRIORITY";

  switch(level)
  {
  case ERROR_LEVEL:
    errorType = "ERROR   ";
    break;
  case WARNING_LEVEL:
    errorType = "WARNING ";
    break;
  case INFO_LEVEL:
    errorType = "INFO    ";
    break;
  case DEBUG_LEVEL:
    errorType = "DEBUG   ";
    break;
  };
  
  _tzset();

  char date[9];
  char time[9];
  _sntprintf(str, 1000, "%s : %s %s: ", errorType, _strdate( date ), _strtime( time ), level );
  return str;
}


void truncateLogFile(const char* logFile)
{
  if (g_InstallDir != 0)
  {
    char fileName[128];
    strncpy(fileName, g_InstallDir, 128);
    strncat(fileName, "\\", 128);
    strncat(fileName, logFile, 128);

    ofstream of(fileName, ios::trunc);
    of.close();
  }
}

void printToLogFile(int level, const char* logFile, const char* theString)
{
  if (level <= g_LogLevel && g_InstallDir != 0)
  {
    // Report to log file in all cases
    char fileName[128];
    strncpy(fileName, g_InstallDir, 128);
    strncat(fileName, "\\", 128);
    strncat(fileName, logFile, 128);

    ofstream of(fileName, ios::app);

    of << getTimeDateString(level);
    of << theString << endl;

    of.close();
  }
}


void printToConsole(int level, const char* theString)
{
  if (g_Debug && level <= g_LogLevel)
  {
    cout << getTimeDateString(level) << theString <<"\n";
    cout.flush();
  }
}


void printToEventLog(int level, const char* theString)
{
  if (!g_Debug && level <= g_LogLevel)
  {
    DWORD errorType;
    switch(level)
    {
    case ERROR_LEVEL:
      errorType = EVENTLOG_ERROR_TYPE;
      break;
    case WARNING_LEVEL:
      errorType = EVENTLOG_WARNING_TYPE;
      break;
    case INFO_LEVEL:
      errorType = EVENTLOG_INFORMATION_TYPE;
      break;
    };
  

    // Use event logging to log the error.
    //
    HANDLE  hEventSource;
    hEventSource = RegisterEventSource(NULL, TEXT(SZSERVICENAME));
  
    TCHAR   szMsg[256];
    //_stprintf(szMsg, TEXT("%s error: %d"), TEXT(SZSERVICENAME), dwErr);
    _stprintf(szMsg, "NetSaint Service Manager");
  
    LPCTSTR lpszStrings[2];
    lpszStrings[0] = szMsg;
    lpszStrings[1] = theString;
  
    if (hEventSource != NULL) {
      ReportEvent(hEventSource, // handle of event source
        errorType,  // event type
        0,                    // event category
        0,                    // event ID
        NULL,                 // current user's SID
        2,                    // strings in lpszStrings
        0,                    // no bytes of raw data
        lpszStrings, // array of error strings
        NULL);                // no raw data
    
      (VOID) DeregisterEventSource(hEventSource);
    }
  }
}


void DEBUG(const char* format, ...)
{
  // Construct a string
  static TCHAR theString[2048];
  theString[0] = 0;
  va_list arglist;
  va_start(arglist, format);
  _vsntprintf(theString, 2048, format, arglist);

  printToEventLog(DEBUG_LEVEL, theString);

  printToConsole(DEBUG_LEVEL, theString);

  printToLogFile(DEBUG_LEVEL, ERRLOG, theString);
}


void printToLog(int level, const char* logFile, const char* format, ...)
{
  // Construct a string
  static TCHAR theString[2048];
  theString[0] = 0;
  va_list arglist;
  va_start(arglist, format);
  _vsntprintf(theString, 2048, format, arglist);

  printToEventLog(level, theString);

  printToConsole(level, theString);

  printToLogFile(level, logFile, theString);
}

void NO_DEBUG(const char* format, ...)
{
  // Do nothing
}
